/// Lista Simplu Inlantuita
#include <fstream>
using  namespace std;



struct nod {
    int info;
    nod* urm;
};

/// adauga un nod la sfarsitul listei
void CreazaLista(nod* &prim, nod* &ultim);
void AdSf(nod* &prim, nod* &ultim, int val);
void ScrieLista(nod* prim);

int main()
{
    nod *prim = nullptr,
        *ultim = nullptr; /// adresele primului si ultimului
                   /// nod din lista
    CreazaLista(prim, ultim);
    ScrieLista(prim);
}

void AdSf(nod* &prim, nod* &ultim, int val)
{
    if (prim == nullptr) /// daca lista e vida
    {
        prim = new nod;
        prim->info = val;
        prim->urm = nullptr;
        ultim = prim;
    }
    else
    {
        nod* p = new nod;
        p->info = val;
        p->urm = nullptr;
        ultim->urm = p;
        ultim = p;
    }
}

void ScrieLista(nod* prim)
{
    ofstream fout("sir.out");
    if (prim == nullptr)
        fout << "Lista vida!";
    else
        for (nod* p = prim; p; p = p->urm)
            fout << p->info << ' ';

    fout.close();
}

void CreazaLista(nod* &prim, nod* &ultim)
{
    ifstream fin("sir.in");
    int v;
    while (fin >> v)
        AdSf(prim, ultim, v);

    fin.close();
}
