/// Operatii elementare cu lista simplu inlantuita
#include <iostream>
using  namespace std;

struct nod {
    int info;
    nod* urm;
};

void AdSf(nod* &prim, nod* &ultim, int val);
void AdInc(nod* &prim, nod* &ultim, int val);
void StInc(nod* &prim, nod* &ultim);
void ScrieLista(nod* prim);

int main()
{
    nod *prim = nullptr,
        *ultim = nullptr;
    char ch;
    int val;
    do
    {
        cout << "S - Adauga la sfarsit\n";
        cout << "I - Adauga la inceput\n";
        cout << "P - Sterge primul nod\n";
        cout << "L - Listeaza\n";
        cout << "X - Iesire\n";

        cin >> ch;
        switch (ch)
        {
            case 'X' :
            case 'x' : cout << "Servus!";
                       break;
            case 'S' :
            case 's' : cout << "Valoarea:"; cin >> val;
                       AdSf(prim, ultim, val); break;

            case 'I' :
            case 'i' : cout << "Valoarea:"; cin >> val;
                       AdInc(prim, ultim, val); break;

            case 'P' :
            case 'p' : StInc(prim, ultim); break;

            case 'L' :
            case 'l' : ScrieLista(prim); break;

            default  : cout << "Alegeti din lista\n"; break;
        }

    } while (ch != 'x' && ch != 'X');

    return 0;
}

void AdSf(nod* &prim, nod* &ultim, int val)
{
    if (prim == nullptr) /// daca lista e vida
    {
        prim = new nod;
        prim->info = val;
        prim->urm = nullptr;
        ultim = prim;
    }
    else
    {
        nod* p = new nod;
        p->info = val;
        p->urm = nullptr;
        ultim->urm = p;
        ultim = p;
    }
}

void AdInc(nod* &prim, nod* &ultim, int val)
{
    if (prim == nullptr)
    {
        prim = new nod;
        prim->info = val;
        prim->urm = nullptr;
        ultim = prim;
    }
    else
    {
        nod* p = new nod;
        p->info = val;
        p->urm = prim;
        prim = p;
    }
}

void ScrieLista(nod* prim)
{
    if (prim == nullptr)
        cout << "Lista vida!\n";
    else
    {
        for (nod* p = prim; p; p = p->urm)
            cout << p->info << ' ';
        cout << '\n';
    }
}

void StInc(nod* &prim, nod* &ultim)
{
    if (prim == nullptr)
        cout << "Lista vida!\n";
    else
        if (prim == ultim) /// avem un singur nod
        {
            delete prim;
            prim = ultim = nullptr;
        }
        else   /// avem cel putin doua noduri
        {
            nod* p = prim;
            prim = prim->urm;
            delete p;
        }

}
